diff --git a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
index 1c44e2c..57f07d1 100644
--- a/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
+++ b/base/server/cms/src/com/netscape/cms/profile/common/EnrollProfile.java
@@ -1471,23 +1634,23 @@ public abstract class EnrollProfile extends BasicProfile
                         parseLRAPopWitness(locale, crm, attr);
                     } else {
                         CMS.debug(
-                                method + " verify POP in CMC because LRA POP Witness control attribute doesnt exist in the CMC request.");
+                                methodPos + " verify POP in CMC because LRA POP Witness control attribute doesnt exist in the CMC request.");
                         if (crm.hasPop()) {
-                            CMS.debug(method + " hasPop true");
+                            CMS.debug(methodPos + " hasPop true");
                             verifyPOP(locale, crm);
                         } else { // no signing POP, then do it the hard way
-                            CMS.debug(method + "hasPop false, need to challenge");
+                            CMS.debug(methodPos + "hasPop false, need to challenge");
                             req.setExtData("cmc_POPchallengeRequired", "true");
                         }
                     }
                 } else {
                     CMS.debug(
-                            method + " verify POP in CMC because LRA POP Witness control attribute doesnt exist in the CMC request.");
+                            methodPos + " verify POP in CMC because LRA POP Witness control attribute doesnt exist in the CMC request.");
                     if (crm.hasPop()) {
-                        CMS.debug(method + " hasPop true");
+                        CMS.debug(methodPos + " hasPop true");
                         verifyPOP(locale, crm);
                     } else { // no signing POP, then do it the hard way
-                        CMS.debug(method + "hasPop false, need to challenge");
+                        CMS.debug(methodPos + "hasPop false, need to challenge");
                         req.setExtData("cmc_POPchallengeRequired", "true");
                     }
                 }
@@ -1495,10 +1658,10 @@ public abstract class EnrollProfile extends BasicProfile
             } else { //!verifyAllow
 
                 if (crm.hasPop()) {
-                    CMS.debug(method + " hasPop true");
+                    CMS.debug(methodPos + " hasPop true");
                     verifyPOP(locale, crm);
                 } else { // no signing POP, then do it the hard way
-                    CMS.debug(method + "hasPop false, need to challenge");
+                    CMS.debug(methodPos + "hasPop false, need to challenge");
                     req.setExtData("cmc_POPchallengeRequired", "true");
                 }
             }
@@ -1835,6 +1998,8 @@ public abstract class EnrollProfile extends BasicProfile
 
     public void fillPKCS10(Locale locale, PKCS10 pkcs10, X509CertInfo info, IRequest req)
             throws EProfileException {
+        String method = "EnrollProfile: fillPKCS10: ";
+        CMS.debug(method + "begins");
         X509Key key = pkcs10.getSubjectPublicKeyInfo();
 
         try {
@@ -1869,7 +2034,7 @@ public abstract class EnrollProfile extends BasicProfile
                 PKCS10Attribute p10Attr = p10Attrs.getAttribute(CertificateExtensions.NAME);
                 if (p10Attr != null && p10Attr.getAttributeId().equals(
                         PKCS9Attribute.EXTENSION_REQUEST_OID)) {
-                    CMS.debug("Found PKCS10 extension");
+                    CMS.debug(method + "Found PKCS10 extension");
                     Extensions exts0 = (Extensions)
                             (p10Attr.getAttributeValue());
                     DerOutputStream extOut = new DerOutputStream();
@@ -1879,24 +2044,22 @@ public abstract class EnrollProfile extends BasicProfile
                     DerInputStream extIn = new DerInputStream(extB);
                     CertificateExtensions exts = new CertificateExtensions(extIn);
                     if (exts != null) {
-                        CMS.debug("Set extensions " + exts);
+                        CMS.debug(method + "Set extensions " + exts);
                         // info.set(X509CertInfo.EXTENSIONS, exts);
                         req.setExtData(REQUEST_EXTENSIONS, exts);
                     }
                 } else {
-                    CMS.debug("PKCS10 extension Not Found");
+                    CMS.debug(method + "PKCS10 extension Not Found");
                 }
             }
 
-            CMS.debug("Finish parsePKCS10 - " + pkcs10.getSubjectName());
+            CMS.debug(method + "Finish parsePKCS10 - " + pkcs10.getSubjectName());
         } catch (IOException e) {
-            CMS.debug("EnrollProfile: Unable to fill PKCS #10: " + e);
-            CMS.debug(e);
+            CMS.debug(method + "Unable to fill PKCS #10: " + e);
             throw new EProfileException(
                     CMS.getUserMessage(locale, "CMS_PROFILE_INVALID_REQUEST"), e);
         } catch (CertificateException e) {
-            CMS.debug("EnrollProfile: Unable to fill PKCS #10: " + e);
-            CMS.debug(e);
+            CMS.debug(method + "Unable to fill PKCS #10: " + e);
             throw new EProfileException(
                     CMS.getUserMessage(locale, "CMS_PROFILE_INVALID_REQUEST"), e);
         }
@@ -2074,8 +2237,11 @@ public abstract class EnrollProfile extends BasicProfile
 
     public void populate(IRequest request)
             throws EProfileException {
-        super.populate(request);
 
+        String method = "EnrollProfile: populate: ";
+        CMS.debug(method + "begins");
+
+        super.populate(request);
     }
 
     /**
@@ -2240,7 +2406,7 @@ public abstract class EnrollProfile extends BasicProfile
     public void verifyPOP(Locale locale, CertReqMsg certReqMsg)
             throws EProfileException {
         String method = "EnrollProfile: verifyPOP: ";
-        CMS.debug(method + "for signing keys");
+        CMS.debug(method + "for signing keys begins.");
 
         String auditMessage = null;
         String auditSubjectID = auditSubjectID();
@@ -2261,10 +2427,10 @@ public abstract class EnrollProfile extends BasicProfile
             CryptoToken verifyToken = null;
             String tokenName = CMS.getConfigStore().getString("ca.requestVerify.token", CryptoUtil.INTERNAL_TOKEN_NAME);
             if (CryptoUtil.isInternalToken(tokenName)) {
-                CMS.debug("POP verification using internal token");
+                CMS.debug(method + "POP verification using internal token");
                 certReqMsg.verify();
             } else {
-                CMS.debug("POP verification using token:" + tokenName);
+                CMS.debug(method + "POP verification using token:" + tokenName);
                 verifyToken = CryptoUtil.getCryptoToken(tokenName);
                 certReqMsg.verify(verifyToken);
             }
@@ -2279,7 +2445,7 @@ public abstract class EnrollProfile extends BasicProfile
             CMS.debug(method + "Unable to verify POP: " + e);
             popFailed(locale, auditSubjectID, auditMessage, e);
         }
-        CMS.debug(method + "ends.");
+        CMS.debug(method + "done.");
     }
 
     private void popFailed(Locale locale, String auditSubjectID, String auditMessage)
diff --git a/base/server/cms/src/com/netscape/cms/profile/constraint/CMCUserSignedSubjectNameConstraint.java b/base/server/cms/src/com/netscape/cms/profile/constraint/CMCUserSignedSubjectNameConstraint.java
new file mode 100644
index 0000000..c71b670
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/profile/constraint/CMCUserSignedSubjectNameConstraint.java
@@ -0,0 +1,141 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package com.netscape.cms.profile.constraint;
+
+import java.util.Locale;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.authentication.IAuthManager;
+import com.netscape.certsrv.base.IConfigStore;
+import com.netscape.certsrv.profile.EProfileException;
+import com.netscape.certsrv.profile.ERejectException;
+import com.netscape.certsrv.profile.IPolicyDefault;
+import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.property.IDescriptor;
+import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.profile.common.EnrollProfile;
+import com.netscape.cms.profile.def.CMCUserSignedSubjectNameDefault;
+
+import netscape.security.x509.CertificateSubjectName;
+import netscape.security.x509.X500Name;
+import netscape.security.x509.X509CertInfo;
+
+/**
+ * This class implements the user subject name constraint for user-signed cmc requests.
+ * It makes sure the signing cert's subjectDN and the rsulting cert match
+ *
+ * @author cfu
+ * @version $Revision$, $Date$
+ */
+public class CMCUserSignedSubjectNameConstraint extends EnrollConstraint {
+
+    public CMCUserSignedSubjectNameConstraint() {
+    }
+
+    public void init(IProfile profile, IConfigStore config)
+            throws EProfileException {
+        super.init(profile, config);
+    }
+
+    public IDescriptor getConfigDescriptor(Locale locale, String name) {
+        return null;
+    }
+
+    public String getDefaultConfig(String name) {
+        return null;
+    }
+
+    /**
+     * Validates the request. The request is not modified
+     * during the validation. User encoded subject name
+     * is copied into the certificate template.
+     */
+    public void validate(IRequest request, X509CertInfo info)
+            throws ERejectException {
+        String method = "CMCUserSignedSubjectNameConstraint: ";
+        String msg = "";
+
+        CMS.debug(method + "validate start");
+        CertificateSubjectName infoCertSN = null;
+            CertificateSubjectName authTokenCertSN = null;
+
+
+        try {
+            infoCertSN = (CertificateSubjectName) info.get(X509CertInfo.SUBJECT);
+            if (infoCertSN == null) {
+                msg = method + "infoCertSN null";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+            CMS.debug(method + "validate user subject ="+
+                      infoCertSN.toString());
+            String certSerial = request.getExtDataInString(IAuthManager.CRED_CMC_SIGNING_CERT);
+            if (certSerial == null) {
+                msg = method + "certSerial null";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+            authTokenCertSN =
+                          EnrollProfile.getCMCSigningCertSNfromCertSerial(certSerial);
+            if (authTokenCertSN == null) {
+                msg = method + "authTokenCertSN null";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+            X500Name infoCertName = (X500Name) infoCertSN.get(CertificateSubjectName.DN_NAME);
+            if (infoCertName == null) {
+                msg = method + "infoCertName null";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+            X500Name authTokenCertName = (X500Name) authTokenCertSN.get(CertificateSubjectName.DN_NAME);
+            if (authTokenCertName == null) {
+                msg = method + "authTokenCertName null";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+            if (infoCertName.equals(authTokenCertName)) {
+                CMS.debug(method + "names match");
+            } else {
+                msg = method + "names do not match";
+                CMS.debug(msg);
+                throw new Exception(msg);
+            }
+
+        } catch (Exception e) {
+            throw new ERejectException(
+                    CMS.getUserMessage(getLocale(request),
+                        "CMS_PROFILE_SUBJECT_NAME_NOT_MATCHED") + e);
+        }
+    }
+
+    public String getText(Locale locale) {
+        return CMS.getUserMessage(locale,
+                   "CMS_PROFILE_CONSTRAINT_CMC_USER_SIGNED_SUBJECT_NAME_TEXT");
+    }
+
+    public boolean isApplicable(IPolicyDefault def) {
+        String method = "CMCUserSignedSubjectNameConstraint: isApplicable: ";
+        if (def instanceof CMCUserSignedSubjectNameDefault) {
+            CMS.debug(method + "true");
+            return true;
+        }
+        CMS.debug(method + "false");
+        return false;
+    }
+}
diff --git a/base/server/cms/src/com/netscape/cms/profile/def/CMCUserSignedSubjectNameDefault.java b/base/server/cms/src/com/netscape/cms/profile/def/CMCUserSignedSubjectNameDefault.java
new file mode 100644
index 0000000..a0816ea
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/profile/def/CMCUserSignedSubjectNameDefault.java
@@ -0,0 +1,159 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2007 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package com.netscape.cms.profile.def;
+
+import java.io.IOException;
+import java.util.Locale;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.authentication.IAuthManager;
+import com.netscape.certsrv.base.IConfigStore;
+import com.netscape.certsrv.profile.EProfileException;
+import com.netscape.certsrv.profile.IEnrollProfile;
+import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.property.Descriptor;
+import com.netscape.certsrv.property.EPropertyException;
+import com.netscape.certsrv.property.IDescriptor;
+import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.profile.common.EnrollProfile;
+
+import netscape.security.x509.CertificateSubjectName;
+import netscape.security.x509.X500Name;
+import netscape.security.x509.X509CertInfo;
+
+/**
+ * This class implements an enrollment default policy
+ * that populates a CMC signing user's subject name
+ * into the certificate template.
+ *
+ * @author cfu
+ * @version $Revision$, $Date$
+ */
+public class CMCUserSignedSubjectNameDefault extends EnrollDefault {
+
+    public static final String VAL_NAME = "name";
+
+    public CMCUserSignedSubjectNameDefault() {
+        super();
+        addValueName(VAL_NAME);
+    }
+
+    public void init(IProfile profile, IConfigStore config)
+            throws EProfileException {
+        super.init(profile, config);
+    }
+
+    public IDescriptor getValueDescriptor(Locale locale, String name) {
+        if (name.equals(VAL_NAME)) {
+            return new Descriptor(IDescriptor.STRING, null, null,
+                    CMS.getUserMessage(locale, "CMS_PROFILE_SUBJECT_NAME"));
+        } else {
+            return null;
+        }
+    }
+
+    public void setValue(String name, Locale locale,
+            X509CertInfo info, String value)
+            throws EPropertyException {
+        if (name == null) {
+            throw new EPropertyException(CMS.getUserMessage(
+                        locale, "CMS_INVALID_PROPERTY", name));
+        }
+        if (name.equals(VAL_NAME)) {
+            X500Name x500name = null;
+
+            try {
+                x500name = new X500Name(value);
+            } catch (IOException e) {
+                CMS.debug(e.toString());
+                // failed to build x500 name
+            }
+            CMS.debug("SubjectNameDefault: setValue name=" + x500name);
+            try {
+                info.set(X509CertInfo.SUBJECT,
+                        new CertificateSubjectName(x500name));
+            } catch (Exception e) {
+                // failed to insert subject name
+                CMS.debug("CMCUserSignedSubjectNameDefault: setValue " + e.toString());
+                throw new EPropertyException(CMS.getUserMessage(
+                            locale, "CMS_INVALID_PROPERTY", name));
+            }
+        } else {
+            throw new EPropertyException(CMS.getUserMessage(
+                        locale, "CMS_INVALID_PROPERTY", name));
+        }
+    }
+
+    public String getValue(String name, Locale locale,
+            X509CertInfo info)
+            throws EPropertyException {
+        if (name == null) {
+            throw new EPropertyException(CMS.getUserMessage(
+                        locale, "CMS_INVALID_PROPERTY", name));
+        }
+        if (name.equals(VAL_NAME)) {
+            CertificateSubjectName sn = null;
+
+            try {
+                sn = (CertificateSubjectName)
+                        info.get(X509CertInfo.SUBJECT);
+                return sn.toString();
+            } catch (Exception e) {
+                // nothing
+            }
+            throw new EPropertyException(CMS.getUserMessage(
+                        locale, "CMS_INVALID_PROPERTY", name));
+        } else {
+            throw new EPropertyException(CMS.getUserMessage(
+                        locale, "CMS_INVALID_PROPERTY", name));
+        }
+    }
+
+    public String getText(Locale locale) {
+        return CMS.getUserMessage(locale, "CMS_PROFILE_DEF_CMC_USER_SIGNED_SUBJECT_NAME");
+    }
+
+    /**
+     * Populates the request with this policy default.
+     */
+    public void populate(IRequest request, X509CertInfo info)
+            throws EProfileException {
+        String method = "CMCUserSignedSubjectNameDefault: populate: ";
+        String msg = "";
+        CMS.debug(method + "begins");
+
+        String signingUserSerial = request.getExtDataInString(IAuthManager.CRED_CMC_SIGNING_CERT);
+        if (info == null) {
+            msg = method + "info null";
+            CMS.debug(msg);
+            throw new EProfileException(msg);
+        }
+
+        CertificateSubjectName certSN = null;
+        try {
+            certSN = EnrollProfile.getCMCSigningCertSNfromCertSerial(signingUserSerial);
+            info.set(X509CertInfo.SUBJECT, certSN);
+            CMS.debug(method + "subjectDN set in X509CertInfo");
+        } catch (Exception e) {
+            msg = method + "exception thrown:" + e;
+            throw new EProfileException(e.toString());
+        }
+        request.setExtData(IEnrollProfile.REQUEST_CERTINFO, info);
+        CMS.debug(method + "ends");
+    }
+}
diff --git a/base/server/cms/src/com/netscape/cms/profile/def/EnrollDefault.java b/base/server/cms/src/com/netscape/cms/profile/def/EnrollDefault.java
index 00d669e..1d5bfc4 100644
--- a/base/server/cms/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/base/server/cms/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -214,17 +214,18 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
      */
     public void populate(IRequest request)
             throws EProfileException {
+        String method = "EnrollDefault: populate: ";
         String name = getClass().getName();
 
         name = name.substring(name.lastIndexOf('.') + 1);
-        CMS.debug(name + ": populate start");
+        CMS.debug(method + name + ": start");
         X509CertInfo info =
                 request.getExtDataInCertInfo(IEnrollProfile.REQUEST_CERTINFO);
 
         populate(request, info);
 
         request.setExtData(IEnrollProfile.REQUEST_CERTINFO, info);
-        CMS.debug(name + ": populate end");
+        CMS.debug(method + name + ": end");
     }
 
     public void addValueName(String name) {
diff --git a/base/server/cms/src/com/netscape/cms/profile/input/CMCCertReqInput.java b/base/server/cms/src/com/netscape/cms/profile/input/CMCCertReqInput.java
index a62d6e9..0a9cae1 100644
--- a/base/server/cms/src/com/netscape/cms/profile/input/CMCCertReqInput.java
+++ b/base/server/cms/src/com/netscape/cms/profile/input/CMCCertReqInput.java
@@ -21,6 +21,8 @@ import java.util.Locale;
 
 import netscape.security.x509.X509CertInfo;
 
+import org.mozilla.jss.asn1.SEQUENCE;
+import org.mozilla.jss.pkix.cmc.PKIData;
 import org.mozilla.jss.pkix.cmc.TaggedRequest;
 
 import com.netscape.certsrv.apps.CMS;
@@ -85,19 +87,32 @@ public class CMCCertReqInput extends EnrollInput implements IProfileInput {
      */
     public void populate(IProfileContext ctx, IRequest request)
             throws EProfileException {
+        String method = "CMCCertReqInput: populate: ";
+        CMS.debug(method + "begins");
+
         String cert_request = ctx.get(VAL_CERT_REQUEST);
         X509CertInfo info =
                 request.getExtDataInCertInfo(EnrollProfile.REQUEST_CERTINFO);
 
         if (cert_request == null) {
-            CMS.debug("CMCCertReqInput: populate - invalid certificate request");
+            CMS.debug(method + "invalid certificate request");
             throw new EProfileException(CMS.getUserMessage(
                         getLocale(request), "CMS_PROFILE_NO_CERT_REQ"));
         }
-        TaggedRequest msgs[] = mEnrollProfile.parseCMC(getLocale(request), cert_request);
+        // cfu: getPKIDataFromCMCblob() is extracted from parseCMC
+        // so it's less confusing
+        //TaggedRequest msgs[] = mEnrollProfile.parseCMC(getLocale(request), cert_request);
+        PKIData pkiData = mEnrollProfile.getPKIDataFromCMCblob(getLocale(request), cert_request);
+        SEQUENCE reqSeq = pkiData.getReqSequence();
+        int nummsgs = reqSeq.size(); // for now we only handle one anyways
+        CMS.debug(method + "pkiData.getReqSequence() called; nummsgs =" + nummsgs);
+        TaggedRequest[] msgs = new TaggedRequest[reqSeq.size()];
+        for (int i = 0; i < nummsgs; i++) {
+            msgs[i] = (TaggedRequest) reqSeq.elementAt(i);
+        }
 
         if (msgs == null) {
-            CMS.debug("CMCCertReqInput: populate - parseCMC returns null TaggedRequest msgs");
+            CMS.debug(method + "TaggedRequest msgs null after getPKIDataFromCMCblob");
             return;
         }
         // This profile only handle the first request in CRMF
diff --git a/base/server/cms/src/com/netscape/cms/profile/input/CertReqInput.java b/base/server/cms/src/com/netscape/cms/profile/input/CertReqInput.java
index e67f5b5..fabd2aa 100644
--- a/base/server/cms/src/com/netscape/cms/profile/input/CertReqInput.java
+++ b/base/server/cms/src/com/netscape/cms/profile/input/CertReqInput.java
@@ -19,10 +19,8 @@ package com.netscape.cms.profile.input;
 
 import java.util.Locale;
 
-import netscape.security.pkcs.PKCS10;
-import netscape.security.util.DerInputStream;
-import netscape.security.x509.X509CertInfo;
-
+import org.mozilla.jss.asn1.SEQUENCE;
+import org.mozilla.jss.pkix.cmc.PKIData;
 import org.mozilla.jss.pkix.cmc.TaggedRequest;
 import org.mozilla.jss.pkix.crmf.CertReqMsg;
 
@@ -37,6 +35,10 @@ import com.netscape.certsrv.property.IDescriptor;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.cms.profile.common.EnrollProfile;
 
+import netscape.security.pkcs.PKCS10;
+import netscape.security.util.DerInputStream;
+import netscape.security.x509.X509CertInfo;
+
 /**
  * This class implements the certificate request input.
  * This input populates 2 main fields to the enrollment page:
@@ -89,13 +91,16 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
      */
     public void populate(IProfileContext ctx, IRequest request)
             throws EProfileException {
+        String method = "CertReqInput: populate: ";
+        CMS.debug(method + "begins");
+
         String cert_request_type = ctx.get(VAL_CERT_REQUEST_TYPE);
         String cert_request = ctx.get(VAL_CERT_REQUEST);
         X509CertInfo info =
                 request.getExtDataInCertInfo(EnrollProfile.REQUEST_CERTINFO);
 
         if (cert_request_type == null) {
-            CMS.debug("CertReqInput: populate - invalid cert request type " +
+            CMS.debug(method + "invalid cert request type " +
                     "");
             throw new EProfileException(
                     CMS.getUserMessage(getLocale(request),
@@ -103,12 +108,14 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
                             ""));
         }
         if (cert_request == null) {
-            CMS.debug("CertReqInput: populate - invalid certificate request");
+            CMS.debug(method + "invalid certificate request");
             throw new EProfileException(CMS.getUserMessage(
                         getLocale(request), "CMS_PROFILE_NO_CERT_REQ"));
         }
 
         if (cert_request_type.equals(EnrollProfile.REQ_TYPE_PKCS10)) {
+            CMS.debug(method + "cert_request_type= REQ_TYPE_PKCS10");
+
             PKCS10 pkcs10 = mEnrollProfile.parsePKCS10(getLocale(request), cert_request);
 
             if (pkcs10 == null) {
@@ -118,6 +125,7 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
 
             mEnrollProfile.fillPKCS10(getLocale(request), pkcs10, info, request);
         } else if (cert_request_type.startsWith(EnrollProfile.REQ_TYPE_KEYGEN)) {
+            CMS.debug(method + "cert_request_type= REQ_TYPE_KEYGEN");
             DerInputStream keygen = mEnrollProfile.parseKeyGen(getLocale(request), cert_request);
 
             if (keygen == null) {
@@ -127,6 +135,7 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
 
             mEnrollProfile.fillKeyGen(getLocale(request), keygen, info, request);
         } else if (cert_request_type.startsWith(EnrollProfile.REQ_TYPE_CRMF)) {
+            CMS.debug(method + "cert_request_type= REQ_TYPE_CRMF");
             CertReqMsg msgs[] = mEnrollProfile.parseCRMF(getLocale(request), cert_request);
 
             if (msgs == null) {
@@ -142,7 +151,18 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
             mEnrollProfile.fillCertReqMsg(getLocale(request), msgs[seqNum.intValue()], info, request
                     );
         } else if (cert_request_type.startsWith(EnrollProfile.REQ_TYPE_CMC)) {
-            TaggedRequest msgs[] = mEnrollProfile.parseCMC(getLocale(request), cert_request);
+            CMS.debug(method + "cert_request_type= REQ_TYPE_CMC");
+            // cfu: getPKIDataFromCMCblob() is extracted from parseCMC
+            // so it's less confusing
+            //TaggedRequest msgs[] = mEnrollProfile.parseCMC(getLocale(request), cert_request);
+            PKIData pkiData = mEnrollProfile.getPKIDataFromCMCblob(getLocale(request), cert_request);
+            SEQUENCE reqSeq = pkiData.getReqSequence();
+            int nummsgs = reqSeq.size(); // for now we only handle one anyways
+            CMS.debug(method + "pkiData.getReqSequence() called; nummsgs =" + nummsgs);
+            TaggedRequest[] msgs = new TaggedRequest[reqSeq.size()];
+            for (int i = 0; i < nummsgs; i++) {
+                msgs[i] = (TaggedRequest) reqSeq.elementAt(i);
+            }
 
             if (msgs == null) {
                 throw new EProfileException(CMS.getUserMessage(
@@ -159,7 +179,7 @@ public class CertReqInput extends EnrollInput implements IProfileInput {
             mEnrollProfile.fillTaggedRequest(getLocale(request), msgs[seqNum.intValue()], info, request);
         } else {
             // error
-            CMS.debug("CertReqInput: populate - invalid cert request type " +
+            CMS.debug(method + "invalid cert request type " +
                     cert_request_type);
             throw new EProfileException(
                     CMS.getUserMessage(getLocale(request),
